# Class HealthSource

java.lang.Object
com.codename1.health.HealthSource

public final class HealthSource extends Object

Where a sample came from -- which app wrote it and, when known, which device produced it.

This matters more than it looks. When a phone and a watch both record steps for the same walk, the store holds two overlapping sets of samples, and every platform counts the walk twice: aggregation is done in shared code from raw samples, so HealthKit's own de-duplicating statistics engine is not in play. Filtering a query by source via `AggregateQuery.addSource(String)` is the way to avoid double-counting -- see the warning on `AggregateQuery`.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HealthSource(String bundleId, String name, String deviceName, String deviceModel, String deviceManufacturer)`
  Creates a source descriptor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `String`
  `getBundleId()`
  The writing app's bundle identifier (iOS) or package name (Android).
  `String`
  `getDeviceManufacturer()`
  The producing device's manufacturer, or null.
  `String`
  `getDeviceModel()`
  The producing device's model, or null.
  `String`
  `getDeviceName()`
  The producing device's name, or null -- for example the user's watch.
  `String`
  `getName()`
  The writing app's display name, or null.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### HealthSource

    public HealthSource(String bundleId, String name, String deviceName, String deviceModel, String deviceManufacturer)
    Creates a source descriptor. Only `bundleId` is required; the rest may be null where the platform does not report them.

- ## Method Details

  - ### getBundleId

    public String getBundleId()
    The writing app's bundle identifier (iOS) or package name (Android). This is the value to pass to `AggregateQuery.addSource(String)`.

  - ### getName

    public String getName()
    The writing app's display name, or null.

  - ### getDeviceName

    public String getDeviceName()
    The producing device's name, or null -- for example the user's watch. Frequently null for manually entered data.

  - ### getDeviceModel

    public String getDeviceModel()
    The producing device's model, or null.

  - ### getDeviceManufacturer

    public String getDeviceManufacturer()
    The producing device's manufacturer, or null.

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`